#include <SoftwareSerial.h>

#define RX 1
#define TX 0

SoftwareSerial bluetooth(TX, RX);
#define pinLED 13

int c1 = 2;
int c2 = 3;
int c3 = 4;
int c4 = 5;
int c5 = 6;

int hs = 7; //hall sensor
int pr1 = A5; //photo resistor 1
int pr2 = A4; //photo resistor 2

int laser = 8;

int coil_time = 15; //default
int active_coils = 5; //default
int active_coils_value = 53;


void setup() {
  //bluetooth.begin(4800);
  bluetooth.begin(9600);
  bluetooth.println("Coil gun bluetooth initialisation...");
  pinMode(pinLED, OUTPUT);
  pinMode(c1, OUTPUT);
  pinMode(c2, OUTPUT);
  pinMode(c3, OUTPUT);
  pinMode(c4, OUTPUT);
  pinMode(c5, OUTPUT);

  pinMode(hs, INPUT);
  pinMode(pr1, INPUT);
  pinMode(pr2, INPUT);

  pinMode(laser, OUTPUT);
}

void loop() {

  //bluetooth.println((digitalRead(hs)));

  int BluetoothData;

  //bluetooth.println(analogRead(pr1));
  //bluetooth.println(analogRead(pr2));
  
  if (bluetooth.available() > 0) {
    BluetoothData=bluetooth.read();
    switch (BluetoothData) {
      case 's':
        shootGate();
        break;

      case 'a':
          digitalWrite(c1, HIGH);
          delay(coil_time);
          digitalWrite(c1, LOW);
        break;
  
      case 'b':
          digitalWrite(c2, HIGH);
          delay(coil_time);
          digitalWrite(c2, LOW);
        break;

      case 'c':
          digitalWrite(c3, HIGH);
          delay(coil_time);
          digitalWrite(c3, LOW);
        break;

      case 'd':
          digitalWrite(c4, HIGH);
          delay(coil_time);
          digitalWrite(c4, LOW);
        break;

      case 'e':
          digitalWrite(c5, HIGH);
          delay(coil_time);
          digitalWrite(c5, LOW);
        break;

      case '0':
        hall();
        
       break;
       
      case 'y':
          discharge();
        break;  

/*
      case 'x':
        active_coils_value = bluetooth.read();
        active_coils = active_coils_value - 48;
        //bluetooth.println(active_coils);
        break;
        */
      case 't':

        String xy = bluetooth.readString();
        int xyz = xy.toInt();
        coil_time = xyz;
        bluetooth.println(xyz);
        break;
  
        
  bluetooth.print("Loading message: ");
        BluetoothData=bluetooth.read();
        while (bluetooth.available() > 0) {
          bluetooth.write(BluetoothData);
          delay(10);
          BluetoothData=bluetooth.read();
        }
        bluetooth.println();
        break;
      case '\r':
        break;
      case '\n':
        break;
      default:
        bluetooth.println("Neznamy prikaz.");
    }
  }

  delay(100);
 
}

void shoot(){
  //bluetooth.println("shooting");
  //digitalWrite(laser, HIGH);
  delay(50);
  active_coils_value = bluetooth.read();
  active_coils = active_coils_value - 48;
  
  int active_coils_i = active_coils + 1;
  for(int i=2; i<=active_coils_i; i++)
  {
    digitalWrite(i, HIGH);
    delay(coil_time);
    digitalWrite(i, LOW);
  }
  gate();
  
}

void hall(){
  int t1 = 0;
  int t2 = 0;
  int t = 0;
  
  digitalWrite(c1, HIGH);
  t1 = millis();
  while((digitalRead(hs)) == 1)
  {
  }
  
  while((digitalRead(hs)) == 0){
        
    }
    digitalWrite(c1, LOW);
    t2 = millis();
    t = t2 - t1;
    bluetooth.println(t);
    
    t1 = 0;
    t2 = 0;
    t = 0;
}

void discharge(){
  digitalWrite(c1, HIGH);
  digitalWrite(c2, HIGH);
  digitalWrite(c3, HIGH);
  digitalWrite(c4, HIGH);
  digitalWrite(c5, HIGH);
  delay(1500);
  digitalWrite(c1, LOW);
  digitalWrite(c2, LOW);
  digitalWrite(c3, LOW);
  digitalWrite(c4, LOW);
  digitalWrite(c5, LOW);

}

void gate(){
  int t1 = 0;
  int t2 = 0;
  int t = 0;

  boolean k = 0;
  //bluetooth.println(analogRead(pr1));
  //bluetooth.println(analogRead(pr2));
  while(t == 0){
    //bluetooth.println("gate");

  while(k != 1)
  {
    if(analogRead(pr1) < 2){
      //bluetooth.println(analogRead(pr1));
      t1 = millis();
      k = 1;
    }

  }
    if(analogRead(pr2) < 2){
      t2 = millis();
      //bluetooth.println(" ");
      //bluetooth.println(pr2);
      t = t2 - t1;  
      break;
      }
    }
    
    //double v = 25/t;
    
    bluetooth.println(t);
    t1 = 0;
    t2 = 0;
    t = 0;
    k = 0;

    digitalWrite(laser, LOW);
}


void shootGate(){

  int t1 = 0;
  int t2 = 0;
  int t = 0;
  boolean k = 0;
  
  //bluetooth.println("shooting");
  //digitalWrite(laser, HIGH);
  //delay(100);
  active_coils_value = bluetooth.read();
  active_coils = active_coils_value - 48;
  
  int active_coils_i = active_coils + 1;
  for(int i=2; i<=active_coils_i; i++)
  {
    digitalWrite(i, HIGH);
    delay(coil_time);
    digitalWrite(i, LOW);
  }
  

  while(t == 0){

    while(k == 0){
      if(analogRead(pr1) < 60){
       //bluetooth.println(analogRead(pr1));
       t1 = micros();
       k = 1;
      }
    }
    
    if(analogRead(pr2) < 60){
      t2 = micros();
      //bluetooth.println(" ");
      //bluetooth.println(pr2);
      t = t2 - t1;  
      break;
      }
    }

    bluetooth.println(t);
    
    t1 = 0;
    t2 = 0;
    t = 0;
    k = 0;
    loop();
}










  

  
