#define X_dir  5
#define X_step 2

#define Y_dir  6
#define Y_step 3

#define Z_dir  7
#define Z_step 4

#define A_dir  13
#define A_step 12

int endx = 9;
int endy = 10;
int endz = 11;
int enda = 12;


int posx = 0;
int posy = 0;
int posz = 0;
int posa = 0;

String data;
int d = 1;

#define stepper_enable 8
int stepspermm = 200;


void setup() {
  pinMode(X_step, OUTPUT);
  pinMode(X_dir, OUTPUT);

  pinMode(Y_dir, OUTPUT);
  pinMode(Y_step, OUTPUT);

  pinMode(Z_dir, OUTPUT);
  pinMode(Z_step, OUTPUT);

  pinMode(A_dir, OUTPUT);
  pinMode(A_step, OUTPUT);

  pinMode(endx, INPUT);
  pinMode(endy, INPUT);
  pinMode(endz, INPUT);
  pinMode(enda, INPUT);
  
  
  pinMode(stepper_enable, OUTPUT);
  digitalWrite(stepper_enable, LOW);
  Serial.begin(9600);
}

void loop() {

  //Serial.println(digitalRead(endy));  

  if (Serial.available() > 0) {
    // read the incoming byte:
    data = Serial.readString();
    Serial.println(data);
    
    //for x axis
    if(data[0] == 'x' or data [0] == 'X'){      
      String StringValX = data;
      StringValX.remove(0, 1);
      int valx = StringValX.toInt();

      Serial.print("moving X to position: ");
      Serial.println(valx);

      if(posx < valx)
      {
        digitalWrite(X_dir, HIGH);
        for(int i=0; i < (valx - posx); i++)
        {
          xstep();
        }
        posx = valx;
      }
      
      if(posx > valx)
      {
        digitalWrite(X_dir, LOW);
        for(int i=0; i < (posx - valx); i++)
        {
          xstep();
        }
        posx = valx;
      }
    }
    //end x axis
    
    //for y axis
    if(data[0] == 'y' or data [0] == 'Y'){      
      String StringValY = data;
      StringValY.remove(0, 1);
      int valy = StringValY.toInt();

      Serial.print("moving Y to position: ");
      Serial.println(valy);

      if(posy < valy)
      {
        digitalWrite(Y_dir, HIGH);
        for(int i=0; i < (valy - posy); i++)
        {
          ystep();
        }
        posy = valy;
      }
      
      if(posy > valy)
      {
        digitalWrite(Y_dir, LOW);
        for(int i=0; i < (posy - valy); i++)
        {
          ystep();
        }
        posy = valy;
      }  
    } 
    //end y axis

    //for z axis
    if(data[0] == 'z' or data [0] == 'z'){      
      String StringValZ = data;
      StringValZ.remove(0, 1);
      int valz = StringValZ.toInt();

      Serial.print("moving Z to position: ");
      Serial.println(valz);

      if(posz < valz)
      {
        digitalWrite(Z_dir, HIGH);
        for(int i=0; i < (valz - posz); i++)
        {
          zstep();
        }
        posz = valz;
      }
      
      if(posz > valz)
      {
        digitalWrite(Z_dir, LOW);
        for(int i=0; i < (posz - valz); i++)
        {
          zstep();
        }
        posz = valz;
      }  
    } 
    //end z axis

    //for A axis
    if(data[0] == 'a' or data [0] == 'A'){      
      String StringValA = data;
      StringValA.remove(0, 1);
      int vala = StringValA.toInt();

      Serial.print("moving A to position: ");
      Serial.println(vala);

      if(posa < vala)
      {
        digitalWrite(A_dir, HIGH);
        for(int i=0; i < (vala - posa); i++)
        {
          astep();
        }
        posa = vala;
      }
      
      if(posa > vala)
      {
        digitalWrite(A_dir, LOW);
        for(int i=0; i < (posa - vala); i++)
        {
          astep();
        }
        posa = vala;
      }  
    } 
    //end A axis


    //homing 
    if(data[0] == 'h' or data [0] == 'H'){
        homex();
        homey();
        homez();   
    }
    
  }
}


void xstep(){
for (int x = 0; x < stepspermm; x++)
  {
    digitalWrite(X_step, HIGH);
    delay(d);
    digitalWrite(X_step, LOW);
    delay(d);
  }
}

void ystep(){
for (int y = 0; y < stepspermm; y++)
  {
    digitalWrite(Y_step, HIGH);
    delay(d);
    digitalWrite(Y_step, LOW);
    delay(d);
  }
}

void zstep(){
for (int z = 0; z < stepspermm; z++)
  {
    digitalWrite(Z_step, HIGH);
    delay(d);
    digitalWrite(Z_step, LOW);
    delay(d);
  }
}

void astep(){
for (int a = 0; a < stepspermm; a++)
  {
    digitalWrite(A_step, HIGH);
    delay(d);
    digitalWrite(A_step, LOW);
    delay(d);
  }
}

void homex(){
  if(data[1] == 'x' or data [1] == 'X') {
        Serial.println("Homing X...");
        digitalWrite(X_dir, LOW);
        while(digitalRead(endx) != 0){
          xstep();
        }
        digitalWrite(X_dir, HIGH);
        for(int i = 0; i < 3; i++){
          xstep();
        }
        digitalWrite(X_dir, LOW);
        while(digitalRead(endx) != 0){
          xstep();
        }
        posx = 0;
      }
}

void homey(){
  if(data[1] == 'y' or data [1] == 'Y') {
        Serial.println("Homing Y...");
        digitalWrite(Y_dir, LOW);
        while(digitalRead(endy) != 0){
          ystep();
        }
        digitalWrite(Y_dir, HIGH);
        for(int i = 0; i < 3; i++){
          ystep();
        }
        digitalWrite(Y_dir, LOW);
        while(digitalRead(endy) != 0){
          ystep();
        }
        posy = 0;
      }
}

void homez(){
  if(data[1] == 'z' or data [1] == 'Z') {
        Serial.println("Homing Z...");
        digitalWrite(Z_dir, LOW);
        while(digitalRead(endz) != 0){
          zstep();
        }
        digitalWrite(Z_dir, HIGH);
        for(int i = 0; i < 3; i++){
          zstep();
        }
        digitalWrite(Z_dir, LOW);
        while(digitalRead(endz) != 0){
          zstep();
        }
        posz = 0;
      }
}
